<?php

/**
 * CleanTalk joomla plugin
 *
 * @version 1.6.5
 * @package Cleantalk
 * @subpackage Joomla
 * @author Artem Leontiev <artdokxxx@gmail.com>, Alexey Znaev (znaeff@mail.ru), Anton Kovalin (9820498@gmail.com)
 * @copyright (C) 2013 Сleantalk team (http://cleantalk.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 */

defined('_JEXEC') or die('Restricted access');
jimport('joomla.plugin.plugin');
jimport('joomla.application.application');
jimport('joomla.application.component.helper');

class plgSystemCleantalk extends JPlugin {
    /**
     * Plugin version string for server
     */
    const ENGINE = 'joomla-165';
    
    /**
     * Default value for hidden field ct_checkjs 
     */
    const CT_CHECKJS_DEF = 0;

    /**
     * Cleantalk instance
     */
    static $CT;

    /**
     * Stoplist checking flag
     */
    static $stoplist_check;

    /**
     * Allow links flag
     */
    static $allow_links;

    /**
     * Tables exist and ready flag
     * If set then tables exist and filled by initial data
     */
    static $tables_ready = FALSE;

    /**
     * Include in head adn fill form
     * @param type $form_id
     * @param type $data
     * @return string
     */
    function fillRegisterFormScriptHTML($form_id, $data, $onLoad = true) {
        $str = "\n";
        
        // setTimeout to fill form under Joomla 1.5
        $str .= 'window.onload = window.setTimeout(\'fillHide()\', 1000); function fillHide() {';

        $str .= 'form = document.getElementById("' . $form_id . '");' . "\n";
        $str .= 'if(form){' . "\n";
        if (!empty($data)) {
            foreach ($data as $key => $val) {
                if (is_array($val)) {
                    foreach ($val as $_key => $_val) {
                        $str .= "\t" . 'if (document.getElementsByName("' . $key . '[' . $_key . ']")) {' . "\n";
                        $str .= "\t\t" . 'if (document.getElementsByName("' . $key . '[' . $_key . ']")[0].type != "hidden") {' . "\n";
                        $str .= "\t\t\t" . 'document.getElementsByName("' . $key . '[' . $_key . ']")[0].value = "' . $_val . '"' . "\n";
                        $str .= "\t\t } \n";
                        $str .= "\t } \n";
                    }
                } else {
                    $str .= "\t" . 'if (document.getElementsByName("' . $key . '")) {' . "\n";
                    $str .= "\t\t" . 'if (document.getElementsByName("' . $key . '")[0].type != "hidden") {' . "\n";
                    $str .= "\t\t\t" . 'document.getElementsByName("' . $key . '")[0].value = "' . $val . '"' . "\n";
                    $str .= "\t\t } \n";
                    $str .= "\t } \n";
                }
            }
        }
        $str .= '}' . "\n";
        $str .= '}' . "\n";
        
        return $str;
    }

    /**
     * Save user registration request_id
     * @return type
     */
    function onBeforeCompileHead() {
        $app = JFactory::getApplication();
        if ($app->isAdmin())
            return;

        $session = JFactory::getSession();
        $username = $session->get("register_username");
        $email = $session->get("register_email");
        $ct_request_id = $session->get("ct_request_id");

        if ($username != '' && $email != '') {
            self::initTables();

            $session->set("register_username", null);
            $session->set("register_email", null);
            $session->set("ct_request_id", null);

            $db = JFactory::getDBO();
            $db->setQuery("SELECT * FROM `#__users` WHERE username='" . $username . "' AND email='" . $email . "'");
            $user = $db->loadRowList();
            if (!empty($user)) {
                $user_id = $user[0][0];
                $db->setQuery("UPDATE `#__users` SET ct_request_id='" . $ct_request_id . "' WHERE id='" . $user_id . "'");
                $db->query("UPDATE `#__users` SET ct_request_id='" . $ct_request_id . "' WHERE id='" . $user_id . "'");
            }
        }
    }

    /**
     * Moderate new user
     */
    function moderateUser() {
        $post = $_POST;
        $ver = new JVersion();
        if (strcmp($ver->RELEASE, '1.5') <= 0) {
            $post_name = isset($post['name']) ? $post['name'] : null;
            $post_username = isset($post['username']) ? $post['username'] : null;
            $post_email = isset($post['email']) ? $post['email'] : null;
        } else {
            $post_name = isset($post['name']) ? $post['name'] : (isset($post['jform']['name']) ? $post['jform']['name'] : null);
            $post_username = isset($post['username']) ? $post['username'] : (isset($post['jform']['username']) ? $post['jform']['username'] : null);
            $post_email = isset($post['email']) ? $post['email'] : (isset($post['jform']['email1']) ? $post['jform']['email1'] : null);
        }

        if (!empty($post_name) || !empty($post_username) || !empty($post_email)) {
            $session = JFactory::getSession();

            $val = $session->get('register_formtime');
            if ($val) {
                $submit_time = time() - (int) $val;
            } else {
                $submit_time = NULL;
            }

            $checkjs = $this->get_ct_checkjs();
            
            self::getCleantalk();
            $ctResponse = self::ctSendRequest(
                    'check_newuser', array(
                        'session_ip' => $this->ct_session_ip($_SERVER['REMOTE_ADDR']),
                        'user_email' => $post_email,
                        'user_name' => $post_name . ' ' . $post_username,
                        'submit_time' => $submit_time,
                        'checkjs' => $checkjs
                    )
            );
            if (!empty($ctResponse) && is_array($ctResponse)) {
                if ($ctResponse['allow'] == 0) {
                    if (isset($ctResponse['no_connection']) && $ctResponse['no_connection'] == 1) {
                        $this->sendAdminEmail("Cleantalk plugin", "*** Can't connect to cleantalk.org ***");
                    } else {
                        $session->set('ct_register_form_data', $post);

                        $app = & JFactory::getApplication();
                        $app->enqueueMessage($ctResponse['comment'], 'error');

                        $uri = & JFactory::getUri();
                        $redirect = $uri->toString();
                        if (strcmp($ver->RELEASE, '1.5') <= 0) {
                            if ($uri->_query == 'option=com_user') {
                                $redirect .= '&view=register';
                            }
                        } else {
                            $redirect = str_replace('?task=registration.register', '', $redirect);
                        }
                        $app->redirect($redirect);
                        die();
                    }
                } else {
                    $comment = self::$CT->addCleantalkComment("", $ctResponse['comment']);
                    $hash = self::$CT->getCleantalkCommentHash($comment);

                    $session->set('register_username', $post_username);
                    $session->set('register_email', $post_email);
                    $session->set('ct_request_id', $hash);
                }
            }
        }
    }

    /**
     * Constructor
     * @param $subject
     * @param $config
     * @return void
     */
    function plgSystemCleantalk(&$subject, $config) {
        parent::__construct($subject, $config);
    }

    ////////////////////////////
    // com_contact related sutff

    /**
     * onValidateContact trigger - used by com_contact
     * @access public
     * @param &$contact
     * @param &$data
     * @return instanceof Exception when fails
     * @since 1.5
     */
    function onValidateContact(&$contact, &$data) {
        $session = JFactory::getSession();

        $val = $session->get('formtime');
        if ($val) {
            $submit_time = time() - (int) $val;
        } else {
            $submit_time = NULL;
        }

        $checkjs = $this->get_ct_checkjs();

        $sendAlarm = FALSE;     // send alarm mail to contact - for 1.5 only

        $ver = new JVersion();
        // constants can be found in components/com_contact/views/contact/tmpl/default_form.php
        if (strcmp($ver->RELEASE, '1.5') <= 0) {  // 1.5 and lower
            $user_name_key = 'name';
            $user_email_key = 'email';
            $subject_key = 'subject';
            $message_key = 'text';
            $sendAlarm = TRUE;
        } else {      // current hiest version by default ('2.5' now)
            $user_name_key = 'contact_name';
            $user_email_key = 'contact_email';
            $subject_key = 'contact_subject';
            $message_key = 'contact_message';
        }

        $baseText = '';
        $prevComments = '';

        $ctResponse = self::ctSendRequest(
            'check_message', array(
                'base_text' => ($baseText . "\n\n\n\n" . $prevComments),
                'user_name' => $data[$user_name_key],
                'user_email' => $data[$user_email_key],
                'message' => $data[$subject_key] . "\n" . $data[$message_key],
                'url' => '',
                'checkjs' => $checkjs,
                'session_ip' => $this->ct_session_ip($_SERVER['REMOTE_ADDR']),
                'submit_time' => $submit_time
            )
        );

        $app = JFactory::getApplication();
        if (!empty($ctResponse) && is_array($ctResponse)) {
            if (array_key_exists('no_connection', $ctResponse) && (int) $ctResponse['no_connection'] > 0) {
                // update email text
                $data[$message_key] .= "\n\n------------------\nUnable to moderate! " . $ctResponse['comment'];

                // we need to send alarm because 1.5 ignores any changes in $data :(
                // see components/com_contact/controller.php, function submit(), $body and $post variables
                if ($sendAlarm) {     // 1.5 only!
                    // code taken from components/com_contact/controller.php, function submit()
                    $MailFrom = $app->getCfg('mailfrom');
                    $FromName = $app->getCfg('fromname');
                    $name = JRequest::getVar('name', '', 'post');
                    $email = JRequest::getVar('email', '', 'post');
                    $mail = JFactory::getMailer();
                    $mail->addRecipient($contact->email_to);
                    $mail->setSender(array($email, $name));
                    $mail->setSubject($FromName . ': Cleantalk alarm!');
                    $mail->setBody("Unable to moderate messages! " . $ctResponse['comment']);
                    $sent = $mail->Send();
                }
            } else {
                if (
                        array_key_exists('blacklisted', $ctResponse) && (int) $ctResponse['blacklisted'] > 0 ||
                        array_key_exists('js_disabled', $ctResponse) && (int) $ctResponse['js_disabled'] > 0 ||
                        $ctResponse['allow'] == 0
                ) {
                    $session->set('formtime', time()); // update session 'formtime'
                    $res_str = $ctResponse['comment'];
                    $app->setUserState('com_contact.contact.data', $data);  // not used in 1.5 :(
                    $stub = JRequest::getString('id');
                    // Redirect back to the contact form.
                    // see http://docs.joomla.org/JApplication::redirect/11.1 - what does last param mean?
                    // but it works! AZ
                    $app->redirect(JRoute::_('index.php?option=com_contact&view=contact&id=' . $stub, false), $res_str, 'warning');
                    return new Exception($res_str); // $res_str not used in com_contact code - see source :(
                }
            }
        }
        $session->clear('formtime'); // clear session 'formtime'
    }

    function sendAdminEmail($subject, $message) {
        $app = JFactory::getApplication();
        
        $mail = JFactory::getMailer();
        $mail->addRecipient($app->getCfg('mailfrom'));
        $mail->setSender(array($app->getCfg('mailfrom'), $app->getCfg('fromname')));
        $mail->setSubject($subject);
        $mail->setBody($message);
        $sent = $mail->Send();
    }

    /**
     * onAfterDispatch trigger - used by com_contact
     * @access public
     * @since 1.5
     */
    function onAfterDispatch() {
        $app = JFactory::getApplication();
        if ($app->isAdmin())
            return;

        $option_cmd = JRequest::getCmd('option');
        $view_cmd = JRequest::getCmd('view');
        $task_cmd = JRequest::getCmd('task');

        if ($option_cmd === 'com_contact' && $view_cmd === 'contact') { // com_contact only
            $ver = new JVersion();
            // constants can be found in  components/com_contact/views/contact/tmpl/default_form.php
            // 'option' and 'view' constants are the same in all versions
            if (strcmp($ver->RELEASE, '1.5') <= 0) {  // 1.5 and lower
                $task_submit = 'submit';
                $form_id = 'emailForm';
            } else {      // current hiest version by default ('2.5' now)
                $task_submit = 'contact.submit';
                $form_id = 'contact-form';
            }
            if ($task_cmd != $task_submit) {
                $document = JFactory::getDocument();
                $content = $document->getBuffer('component');
                $needle = '/(<\/form>)/';
                $newContent = preg_replace($needle, $this->getJSTest() . ' $1 ', $content);
                $document->setBuffer($newContent, 'component');
            }
       }
        $ver = new JVersion();
        if (strcmp($ver->RELEASE, '1.5') <= 0) {
            if ($option_cmd == 'com_user') {
                $document = JFactory::getDocument();
                $content = $document->getBuffer('component');
                $needle = '/(<\/form>)/';
                $newContent = preg_replace($needle, $this->getJSTest() . ' $1 ', $content);
                $document->setBuffer($newContent, 'component');
            }
        } else {
            if ($option_cmd == 'com_users') {
                $document = JFactory::getDocument();
                $content = $document->getBuffer('component');
                $needle = '/(<\/form>)/';
                $newContent = preg_replace($needle, $this->getJSTest() . ' $1 ', $content);
                $document->setBuffer($newContent, 'component');
            }
        }
        if ($option_cmd == 'com_virtuemart') {
            if ($task_cmd == 'editaddresscart' || $task_cmd == 'editaddresscheckout') {
                $document = JFactory::getDocument();
                $content = $document->getBuffer('component');
                $needle = '/(<input type="hidden" name="option" value="com_virtuemart"\/>)/';
                $newContent = preg_replace($needle, $this->getJSTest() . ' $1 ', $content);
                $document->setBuffer($newContent, 'component');
            }
        }
     }

    /**
     * onAfterRoute trigger - used by com_contact
     * @access public
     * @since 1.5
     */
    function onAfterRoute() {
        $option_cmd = JRequest::getCmd('option');
        $view_cmd = JRequest::getCmd('view');
        $task_cmd = JRequest::getCmd('task');
        $ver = new JVersion();
        $app = JFactory::getApplication();
        if ($app->isAdmin()) {
            if ($option_cmd == 'com_users') {
                $task_cmd_remove = 'users.delete'; //2.5
                if (strcmp($ver->RELEASE, '1.5') <= 0) {
                    $task_cmd_remove = 'remove';
                }
                if ($task_cmd == $task_cmd_remove) {
                    // Отсылаем фидбэк
                    $a = 1;
                    if (!empty($_POST['cid'])) {
                        $db = JFactory::getDBO();
                        $db->setQuery("SELECT * FROM `#__users` WHERE id IN(" . implode(', ', $_POST['cid']) . ")");
                        $users = $db->loadAssocList();
                        if (!empty($users)) {
                            foreach ($users as $column) {
                                if (!empty($column['ct_request_id'])) {

                                    $ctFbParams = array(
                                        'moderate' => array(
                                            array('msg_hash' => $column['ct_request_id'], 'is_allow' => 0),
                                        ),
                                    );

                                    self::ctSendRequest('send_feedback', $ctFbParams);
                                }
                            }
                        }
                    }
                }
            }
        }

        if ($option_cmd == 'com_contact') {    // com_contact only
            $ver = new JVersion();
            // constants can be found in  components/com_contact/views/contact/tmpl/default_form.php
            // 'option' and 'view' constants are the same in all versions
            if (strcmp($ver->RELEASE, '1.5') <= 0) {  // 1.5 and lower
                $task_submit = 'submit';
            } else {      // current hiest version by default ('2.5' now)
                $task_submit = 'contact.submit';
            }

            $session = JFactory::getSession();
            if ($task_cmd == $task_submit) {   // contact from submit
                $val = $session->get('formtime');
                if ($val) {
                    $submit_time = time() - (int) $val;
                } else {
                    $submit_time = NULL;
                }
            } else if ($view_cmd == 'contact') {  // contact from show
                $time2set = time();
                $session->set('formtime', $time2set);
            }
        }

        $ver = new JVersion();
        // constants can be found in  components/com_contact/views/contact/tmpl/default_form.php
        // 'option' and 'view' constants are the same in all versions
        if (strcmp($ver->RELEASE, '1.5') <= 0) {
            if ($option_cmd == 'com_user') {
                if ($task_cmd == 'register_save') {
                    $this->moderateUser();
                } else {
                    $session = JFactory::getSession();
                    $document = & JFactory::getDocument();

                    $session->set('register_formtime', time());
                    $ct_form_data = $session->get('ct_register_form_data');
                    $session->set('ct_register_form_data', null);
                    $document->addScriptDeclaration($this->fillRegisterFormScriptHTML('josForm', $ct_form_data));
                }
            }
            if ($option_cmd == 'com_virtuemart') {
                if ($task_cmd == 'registercartuser' || $task_cmd == 'registercheckoutuser') {
                    $this->moderateUser();
                } else {
                    $session = JFactory::getSession();
                    $document = & JFactory::getDocument();

                    $session->set('register_formtime', time());
                    //$document->addScriptDeclaration($this->getRegisterFormScriptHTML('userForm'));
                    $ct_form_data = $session->get('ct_register_form_data');
                    $session->set('ct_register_form_data', null);
                    $document->addScriptDeclaration($this->fillRegisterFormScriptHTML('userForm', $ct_form_data));
                }
            }
        } else {
            //com_users - registration - registration.register
            if ($option_cmd == 'com_users') {
                if ($task_cmd == 'registration.register') {
                    $this->moderateUser();
                } else {
                    $session = JFactory::getSession();
                    $document = & JFactory::getDocument();

                    $session->set('register_formtime', time());
                    $ct_form_data = $session->get('ct_register_form_data');
                    $session->set('ct_register_form_data', null);
                    $document->addScriptDeclaration($this->fillRegisterFormScriptHTML('member-registration', $ct_form_data));
                }
            }
            if ($option_cmd == 'com_virtuemart') {
                if ($task_cmd == 'editaddresscart') {
                    $session = JFactory::getSession();
                    $document = & JFactory::getDocument();

                    $session->set('register_formtime', time());
                    //$document->addScriptDeclaration($this->getRegisterFormScriptHTML('userForm'));
                    $ct_form_data = $session->get('ct_register_form_data');
                    $session->set('ct_register_form_data', null);
                    $document->addScriptDeclaration($this->fillRegisterFormScriptHTML('userForm', $ct_form_data));
                } elseif ($task_cmd == 'registercartuser' || $task_cmd == 'registercheckoutuser') {
                    $this->moderateUser();
                }
            }
        }
    }

    ////////////////////////////
    // JComments related sutff

    /* List of available triggers in JComments 2.3.0 - jcomments.ajax.php

      onJCommentsCaptchaVerify
      onJCommentsCommentBeforeAdd	- used, working
      onJCommentsCommentAfterAdd
      onJCommentsCommentBeforeDelete
      onJCommentsCommentAfterDelete	- used, but not called from comments admin panel
      onJCommentsCommentBeforePublish - used, working
      onJCommentsCommentAfterPublish
      onJCommentsCommentBeforeChange
      onJCommentsCommentAfterChange
      onJCommentsCommentBeforeVote
      onJCommentsCommentAfterVote
      onJCommentsCommentBeforeReport
      onJCommentsCommentAfterReport
      onJCommentsUserBeforeBan
      onJCommentsUserAfterBan

     */
    
    /**
     * onJCommentsFormAfterDisplay trigger
     * @access public
     * @return string html code to insert after JComments form (id="comments-form")
     * @since 1.5
     */
    function onJCommentsFormAfterDisplay() {
        $session = JFactory::getSession();
        $session->set('formtime', time());
        return $this->getJSTest(); // id of JComments form doesn't depends on Joomla version
    }

    /**
     * onJCommentsCommentBeforeAdd trigger
     * @access public
     * @param JCommentsDB $comment
     * @return bolean true
     * @since 1.5
     */
    function onJCommentsCommentBeforeAdd(&$comment) {
        $session = JFactory::getSession();
        $val = $session->get('formtime');
        if ($val) {
            $submit_time = time() - (int) $val;
        } else {
            $submit_time = NULL;
        }

        // set new time because onJCommentsFormAfterDisplay worked only once
        // and formtime in session need to be renewed between ajax posts
        $session->set('formtime', time());
        
        // Disabling tests JavaScript, because at JComments JS always should be enabled at client's browser
        $checkjs = 1; 

        $plugin_groups = array();
        $param_groups = $this->params->get('groups');
        if (is_array($param_groups)) {
            foreach ($param_groups as $group) {
                array_push($plugin_groups, (int) $group);
            }
        } else {
            array_push($plugin_groups, (int) $param_groups);
        }

        $user = JFactory::getUser();
        if (method_exists($user, 'getAuthorisedGroups')) {    // 1.6+
            $user_groups = $user->getAuthorisedGroups();
        } else {                                              // 1.5
            $user_groups = array();
            if ($user->guest) {
                array_push($user_groups, 29);
            } else {
                array_push($user_groups, $user->gid);
            }
        }
        foreach ($user_groups as $group) {
            if (in_array($group, $plugin_groups)) {
                switch ($comment->object_group) {
                    case 'com_content':
                        $article = JTable::getInstance('content');
                        $article->load($comment->object_id);
                        $baseText = $article->introtext . '<br>' . $article->fulltext;
                        break;
                    default:
                        $baseText = '';
                }

                $db = JCommentsFactory::getDBO();
                $query = "SELECT comment "
                        . "\nFROM #__jcomments "
                        . "\nWHERE published = 1 "
                        . "\n  AND object_group = '" . $db->getEscaped($comment->object_group) . "'"
                        . "\n  AND object_id = " . $comment->object_id
                        . (JCommentsMultilingual::isEnabled() ? "\nAND lang = '" . JCommentsMultilingual::getLanguage() . "'" : "")
                        . " ORDER BY id DESC "
                        . " LIMIT 10 "
                ;
                $db->setQuery($query);
                $prevComments = $db->loadResultArray();
                $prevComments = $prevComments == NULL ? '' : implode("\n\n", $prevComments);

                $ctResponse = self::ctSendRequest(
                    'check_message', array(
                        'base_text' => ($baseText . "\n\n\n\n" . $prevComments),
                        'user_name' => $comment->name,
                        'user_email' => $comment->email,
                        'message' => $comment->comment,
                        'url' => '',
                        'checkjs' => $checkjs,
                        'session_ip' => $this->ct_session_ip($_SERVER['REMOTE_ADDR']),
                        'submit_time' => $submit_time
                    )
                );

                if (!empty($ctResponse) && is_array($ctResponse)) {
                    if (
                            array_key_exists('blacklisted', $ctResponse) && (int) $ctResponse['blacklisted'] > 0 ||
                            array_key_exists('js_disabled', $ctResponse) && (int) $ctResponse['js_disabled'] > 0
                    ) {
                        JCommentsAJAX::showErrorMessage($ctResponse['comment'], 'comment');
                        return false;
                    } else if ($ctResponse['allow'] == 0) {
                        $comment->published = false;
                        $comment->comment = self::$CT->addCleantalkComment($comment->comment, $ctResponse['comment']);
                    }
                }
                return true;
            } //if(in_array($group, $plugin_groups))
        } //foreach
    }

    /**
     * onJCommentsCommentBeforePublish trigger
     * @access public
     * @param JCommentsDB $comment
     * @return bolean true
     * @since 1.5
     */
    function onJCommentsCommentBeforePublish(&$comment) {
        self::moderateMessage($comment->comment, 1);
        return true;
    }

    /**
     * onJCommentsCommentAfterDelete trigger
     * @access public
     * @param JCommentsDB $comment
     * @return bolean true
     * @since 1.5
     */
    function onJCommentsCommentAfterDelete(&$comment) {
        self::moderateMessage($comment->comment, 0);
        return true;
    }

    ////////////////////////////
    // Common basic sutff

    /**
     * Function to send the results of moderation
     * @param $message
     * @param $allow
     * @return void
     */
    function moderateMessage(&$message, $allow) {
        self::getCleantalk();
        $hash = self::$CT->getCleantalkCommentHash($message);
        $resultMessage = self::$CT->delCleantalkComment($message);

        if ($hash != NULL) {
            $ctFbParams = array(
                'moderate' => array(
                    array('msg_hash' => $hash, 'is_allow' => $allow),
                ),
            );

            self::ctSendRequest(
                    'send_feedback', $ctFbParams
            );
        }

        $message = $resultMessage;
    }

    /**
     * Interface to XML RPC server
     * $mehod - method name
     * $params - array of XML params
     * return XML RPS server response
     */
    function ctSendRequest($method, $params) {
        self::getCleantalk();

        switch ($method) {
            case 'check_message':
                $sender_id = self::$CT->getSenderId();
                $params = array(
                    $params['message'],
                    $params['base_text'],
                    self::$CT->config['auth_key'],
                    self::ENGINE,
                    $params['url'],
                    self::$stoplist_check,
                    self::$CT->config['response_lang'],
                    $params['session_ip'],
                    $params['user_email'],
                    $params['user_name'],
                    $sender_id,
                    self::$allow_links,
                    $params['submit_time'],
                    $params['checkjs']
                );
                break;
            case 'send_feedback':
                $feedback = array();
                foreach ($params['moderate'] as $msgFeedback)
                    $feedback[] = $msgFeedback['msg_hash'] . ':' . intval($msgFeedback['is_allow']);

                $feedback = implode(';', $feedback);

                $params = array(
                    self::$CT->config['auth_key'],
                    $feedback,
                );
                break;
            case 'check_newuser':
                $params = array(
                    self::$CT->config['auth_key'],
                    self::ENGINE,
                    self::$CT->config['response_lang'],
                    $params['session_ip'],
                    $params['user_email'],
                    $params['user_name'],
                    '', //Time Zone
                    $params['submit_time'],
                    $params['checkjs']
                );
                break;
            default:
                return NULL;
        }

        $plugin_url = self::$CT->config['server_url'];
        $config = self::dbGetServer();
        $result = NULL;

        if ((isset($config['ct_work_url']) && $config['ct_work_url'] !== '') && ($config['ct_server_changed'] + $config['ct_server_ttl'] > time())) {
            $result = self::$CT->xmlRequest2(
                    $method, $params, $config['ct_work_url']
            );
        }

        if (!isset($result) || $result->faultCode()) {
            $matches = array();
            preg_match("#^(http://|https://)([a-z\.\-0-9]+):?(\d*)$#i", $plugin_url, $matches);
            $url_prefix = $matches[1];
            $pool = $matches[2];
            $port = $matches[3];
            if (empty($url_prefix))
                $url_prefix = 'http://';
            if (empty($pool)) {
                $result = array(
                    'allow' => 0,
                    'comment' => 'Can\'t connect to cleantalk.org',
                    'blacklisted' => 0,
                );
            } else {
                foreach (dns_get_record($pool, DNS_A) as $server) {
                    $server_host = gethostbyaddr($server['ip']);
                    $work_url = $url_prefix . $server_host;
                    if ($server['host'] === 'localhost')
                        $work_url = $url_prefix . $server['host'];

                    $work_url = ($port !== '') ? $work_url . ':' . $port : $work_url;

                    $result = self::$CT->xmlRequest2(
                            $method, $params, $work_url
                    );

                    if (!$result->faultCode()) {
                        self::dbSetServer($work_url, $server['ttl'], time());
                        break;
                    }
                }
                if (!$result) {
                    $result = self::$CT->xmlRequest2(
                            $method, $params, $plugin_url
                    );
                }
            }
        }

        if (is_object($result) && !$result->faultCode()) {
            $result = $result->value();

            if ($method === 'check_message' && $sender_id == '' && isset($result['sender_id']))
                self::$CT->setSenderId($result['sender_id']);
        }else {
            $result = array(
                'allow' => 0,
                'comment' => 'Can\'t connect to cleantalk.org',
                'blacklisted' => 0,
                'no_connection' => 1
            );
        }

        return $result;
    }

    /**
     * Cleantalk instance
     * @return Cleantalk instance
     */
    function getCleantalk() {
        if (!isset(self::$CT)) {

            $config = $this->getCTConfig();
            if (empty($config['lang'])) {
                $lang = JFactory::getLanguage();
                $config['lang'] = substr($lang->getTag(), 0, 2);
            }

            self::$stoplist_check = $config['stoplist'];
            self::$allow_links = $config['links'];
            
            defined('_JEXEC') or die('Restricted access');
            if(!defined('DS')){
                define('DS', DIRECTORY_SEPARATOR);
            }
            
            require_once(dirname(__FILE__) . DS . 'cleantalk.class.php');
            self::$CT = new Cleantalk(array(
                        'auth_key' => $config['apikey'],
                        'response_lang' => $config['lang'],
                        'server_url' => $config['server']
                    ));
        }
        return self::$CT;
    }
    
    /**
     * Interface to get CT options 
     * @return array 
     */
    function getCTConfig() {
        $plugin = JPluginHelper::getPlugin('system', 'cleantalk');
            
        $config['apikey'] = ''; 
        $config['server'] = '';
        $config['lang'] = ''; 
        $config['stoplist'] = ''; 
        $config['links'] = '';
        if (class_exists('JParameter')) {   //1.5
            $jparam = new JParameter($plugin->params);
            $config['apikey'] = $jparam->def('apikey', '');
            $config['server'] = $jparam->def('server', '');
            $config['lang']= $jparam->def('lang', '');
            $config['stoplist'] = $jparam->def('stoplist', '1');
            $config['links'] = $jparam->def('links', '0');
        } else {      //1.6+
            $jreg = new JRegistry($plugin->params);
            $config['apikey'] = $jreg->get('apikey', '');
            $config['server'] = $jreg->get('server', '');
            $config['lang'] = $jreg->get('lang', '');
            $config['stoplist'] = $jreg->get('stoplist', '1');
            $confgi['links'] = $jreg->get('links', '0');
        }

        return $config;
    }


    /**
     * Cleantalk tables creator
     * @return bool
     */
    function initTables() {
        $db = JFactory::getDBO();
        $prefix = $db->getPrefix();
        $arrTables = $db->getTableList();

        $db->setQuery("SHOW COLUMNS FROM `#__users`");
        $users_columns = $db->loadRowList();
        $field_presence = false;

        foreach ($users_columns as $column) {
            if ($column[0] == 'ct_request_id') {
                $field_presence = true;
            }
        }

        if (!$field_presence) {
            $db->setQuery("ALTER TABLE `#__users` ADD ct_request_id char(32) NOT NULL DEFAULT ''");
            $db->query();
        }

        if (!empty($arrTables)) {
            if (!in_array($prefix . 'ct_curr_server', $arrTables)) {
                $db->setQuery("CREATE TABLE `#__ct_curr_server` (
			`id` int(11) unsigned NOT NULL auto_increment,
			`ct_work_url` varchar(100) default NULL,
			`ct_server_ttl` int(11) NOT NULL default '0',
			`ct_server_changed` int(11) NOT NULL default '0',
			PRIMARY KEY (`id`)
			) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8");
                $db->query();
            }

            $db->setQuery("SELECT count(*) FROM #__ct_curr_server");
            $row = $db->loadRow();
            if ($row[0] == 0) {
                $db->setQuery(
                        "INSERT  " .
                        "INTO #__ct_curr_server (ct_work_url,ct_server_ttl,ct_server_changed ) " .
                        "VALUES ('', 0, 0)");
                if ($db->query() !== FALSE)
                    self::$tables_ready = TRUE;
            }else {
                self::$tables_ready = TRUE;
            }
        }
        return self::$tables_ready;
    }

    /**
     * Current server getter
     * @return array
     */
    function dbGetServer() {
        if (!self::$tables_ready) {
            self::initTables();
        }
        $db = JFactory::getDBO();
        $db->setQuery("SELECT ct_work_url,ct_server_ttl,ct_server_changed FROM #__ct_curr_server ORDER BY id LIMIT 1");
        $row = $db->loadAssoc();
        return $row;
    }

    /**
     * Current server setter
     * $ct_work_url
     * $ct_server_ttl
     * $ct_server_changed
     * @return null
     */
    function dbSetServer($ct_work_url, $ct_server_ttl, $ct_server_changed) {
        if (!self::$tables_ready) {
            self::initTables();
        }
        $db = JFactory::getDBO();
        $db->setQuery(
                "UPDATE #__ct_curr_server " .
                " SET " .
                "ct_work_url = '" . $ct_work_url . "', " .
                "ct_server_ttl = " . $ct_server_ttl . ", " .
                "ct_server_changed = " . $ct_server_changed);
        $db->query();
    }
  
    /**
    * Get value of $ct_checkjs
    * JavaScript avaibility test.
    * @return null|0|1    
    */
    function get_ct_checkjs(){
        
        $checkjs = 0;
        if (isset($_REQUEST['ct_checkjs'])) {
            $config = $this->getCTConfig();
            try {
                $checkjs_valid = md5($config['apikey'] . $_SERVER['REMOTE_ADDR']);
            } catch (Exception $e) {
                $checkjs_valid = 1;
            }
            if ($checkjs_valid == $_POST['ct_checkjs']) {
                $checkjs = 1;
            }
        }
        $option_cmd = JRequest::getCmd('option');
            
        // Return null if ct_checkjs is not set, because VirtueMart not need strict JS test
        if (!isset($_REQUEST['ct_checkjs']) && $option_cmd = 'com_virtuemart')
           $checkjs = null; 
        
        return $checkjs;
    }

    /**
     * Gets HTML code with link to Cleantalk site
     * @access public
     * @return string HTML code
     * @since 1.5
     */
    function getJSTest() {
        $config = $this->getCTConfig();
        try {
            $ct_checkjs_key = md5($config['apikey'] . $_SERVER['REMOTE_ADDR']);
        } catch (Exception $e) {
            $ct_checkjs_key = 1;
        }

        $str = '<input type="hidden" id="ct_checkjs" name="ct_checkjs" value="' . self::CT_CHECKJS_DEF . '" />'. "\n";
        $str .= '<script type="text/javascript">'. "\n";
        $str .= '// <![CDATA['. "\n";
        $str .= 'document.getElementById("ct_checkjs").value = document.getElementById("ct_checkjs").value.replace("' . self::CT_CHECKJS_DEF . '", "' . $ct_checkjs_key . '");'. "\n";
        $str .= '// ]]>'. "\n";
        $str .= '</script>'. "\n";
        
        return $str;
    }

    /**
     * Get session_ip
     *
     * @param $data_ip - $_SERVER['REMOTE_ADDR']
     * @return string
     */

    function ct_session_ip($data_ip)
    {
        if (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) {
            $forwarded_for = (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) ? htmlentities($_SERVER['HTTP_X_FORWARDED_FOR']) : '';
        }
        
        // 127.0.0.1 usually used at reverse proxy
        $session_ip = ($data_ip == '127.0.0.1' && !empty($forwarded_for)) ? $forwarded_for : $data_ip;


        return $session_ip;
    } 
}
